glibmm: Gio::FileIOStream Class Reference

glibmm 2.66.8

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gio::FileIOStream Class Reference
Stream Classes

FileIOStream provides input streams that take their content from a file. More...

`#include <giomm/fileiostream.h>`

Inheritance diagram for Gio::FileIOStream:
[legend]

## Public Member Functions
| FileIOStream (FileIOStream && src) noexcept
FileIOStream & | operator= (FileIOStream && src) noexcept
| ~FileIOStream () noexcept override
GFileIOStream * | gobj ()
| Provides access to the underlying C GObject.
const GFileIOStream * | gobj () const
| Provides access to the underlying C GObject.
GFileIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< FileInfo > | query_info (const Glib::RefPtr< Cancellable > & cancellable, const std::string & attributes="*")
| Queries a file input stream the given attributes.
Glib::RefPtr< FileInfo > | query_info (const std::string & attributes="*")
| Queries a file input stream the given attributes.
void | query_info_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, const std::string & attributes="*", int io_priority=Glib::PRIORITY_DEFAULT)
| Queries the stream information asynchronously.
void | query_info_async (const SlotAsyncReady & slot, const std::string & attributes="*", int io_priority=Glib::PRIORITY_DEFAULT)
| Queries the stream information asynchronously.
Glib::RefPtr< FileInfo > | query_info_finish (const Glib::RefPtr< AsyncResult > & result)
| Finalizes the asynchronous query started by g_file_io_stream_query_info_async().
std::string | get_etag () const
| Gets the entity tag for the file when it has been written.
Public Member Functions inherited from Gio::IOStream
| IOStream (IOStream && src) noexcept
IOStream & | operator= (IOStream && src) noexcept
| ~IOStream () noexcept override
GIOStream * | gobj ()
| Provides access to the underlying C GObject.
const GIOStream * | gobj () const
| Provides access to the underlying C GObject.
GIOStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream.
void | splice_async (const Glib::RefPtr< IOStream > & stream2, const SlotAsyncReady & slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async().
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable > & cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult > & result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::Seekable
| Seekable (Seekable && src) noexcept
Seekable & | operator= (Seekable && src) noexcept
| ~Seekable () noexcept override
GSeekable * | gobj ()
| Provides access to the underlying C GObject.
const GSeekable * | gobj () const
| Provides access to the underlying C GObject.
goffset | tell () const
| Tells the current position within the stream.
bool | can_seek () const
| Tests if the stream supports the SeekableIface.
bool | seek (goffset offset, Glib::SeekType type, const Glib::RefPtr< Cancellable > & cancellable)
| Seeks in the stream by the given offset, modified by type.
bool | seek (goffset offset, Glib::SeekType type)
| A seek() convenience overload.
bool | can_truncate () const
| Tests if the length of the stream can be adjusted with g_seekable_truncate().
bool | truncate (goffset offset, const Glib::RefPtr< Cancellable > & cancellable)
| Truncates a stream with a given #offset.
bool | truncate (goffset offset)
| A truncate() convenience overload.
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor.
| Interface (Interface && src) noexcept
Interface & | operator= (Interface && src) noexcept
| Interface (const Glib::Interface_Class & interface_class)
| Called by constructors of derived classes.
| Interface (GObject * castitem)
| Called by constructors of derived classes.
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static bool | splice_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes an asynchronous io stream splice operation.
Static Public Member Functions inherited from Gio::Seekable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::FileIOStream > | wrap (GFileIOStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)
Related Symbols inherited from Gio::Seekable
Glib::RefPtr< Gio::Seekable > | wrap (GSeekable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)
Protected Member Functions inherited from Gio::Seekable
| Seekable ()
| You should derive from this class to use it.

## Detailed Description

FileIOStream provides input streams that take their content from a file.

FileInputStream implements Seekable, which allows the input stream to jump to arbitrary positions in the file, provided the file system of the file allows it. Use the methods of the Seekable base class for seeking and positioning.

Since glibmm 2.22

## Constructor & Destructor Documentation

## ◆ FileIOStream()

Gio::FileIOStream::FileIOStream | ( | FileIOStream && | src | ) |
| noexcept

## ◆ ~FileIOStream()

Gio::FileIOStream::~FileIOStream | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ get_etag()

std::string Gio::FileIOStream::get_etag | ( |  | ) | const

Gets the entity tag for the file when it has been written.

This must be called after the stream has been written and closed, as the etag can change while writing.

Since glibmm 2.22

Returns
  The entity tag for the stream.

## ◆ get_type()

static GType Gio::FileIOStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GFileIOStream * Gio::FileIOStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GFileIOStream * Gio::FileIOStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GFileIOStream * Gio::FileIOStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FileIOStream & Gio::FileIOStream::operator= | ( | FileIOStream && | src | ) |
| noexcept

## ◆ query_info() [1/2]

Glib::RefPtr< FileInfo > Gio::FileIOStream::query_info | ( | const Glib::RefPtr< Cancellable > & | cancellable,
|  | const std::string & | attributes = "*" )

Queries a file input stream the given attributes.

This function blocks while querying the stream. For the asynchronous (non-blocking) version of this function, see query_info_async(). While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will throw a Gio::Error with PENDING.

Parameters

  attributes | A file attribute query string.
  cancellable | A Cancellable object.

Returns
  A FileInfo, or an empty RefPtr on error.

## ◆ query_info() [2/2]

Glib::RefPtr< FileInfo > Gio::FileIOStream::query_info | ( | const std::string & | attributes = "*" | ) |

Queries a file input stream the given attributes.

This function blocks while querying the stream. For the asynchronous (non-blocking) version of this function, see query_info_async(). While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will throw a Gio::Error with PENDING.

Parameters

  attributes | A file attribute query string.

Returns
  A FileInfo, or an empty RefPtr on error.

## ◆ query_info_async() [1/2]

void Gio::FileIOStream::query_info_async | ( | const SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Cancellable > & | cancellable,
|  | const std::string & | attributes = "*",
|  | int | io_priority = Glib::PRIORITY_DEFAULT )

Queries the stream information asynchronously.

For the synchronous version of this function, see query_info().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error with CANCELLED will be thrown.

When the operation is finished, slot will be called. You can then call query_info_finish() to get the result of the operation.

Parameters

  slot | A callback slot which will be called when the request is satisfied.
  cancellable | A Cancellable object which can be used to cancel the operation.
  attributes | A file attribute query string.
  io_priority | The I/O priority of the request.

## ◆ query_info_async() [2/2]

void Gio::FileIOStream::query_info_async | ( | const SlotAsyncReady & | slot,
|  | const std::string & | attributes = "*",
|  | int | io_priority = Glib::PRIORITY_DEFAULT )

Queries the stream information asynchronously.

For the synchronous version of this function, see query_info().

When the operation is finished, slot will be called. You can then call query_info_finish() to get the result of the operation.

Parameters

  slot | A callback slot which will be called when the request is satisfied.
  attributes | A file attribute query string.
  io_priority | The I/O priority of the request.

## ◆ query_info_finish()

Glib::RefPtr< FileInfo > Gio::FileIOStream::query_info_finish | ( | const Glib::RefPtr< AsyncResult > & | result | ) |

Finalizes the asynchronous query started by g_file_io_stream_query_info_async().

Since glibmm 2.22

Parameters

  result | A AsyncResult.

Returns
  A FileInfo for the finished query.

Exceptions

  Glib::Error |

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::FileIOStream > wrap | ( | GFileIOStream * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.